// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#ifndef OmSourceBackgroundDlg_h
#define OmSourceBackgroundDlg_h
#include <qapplication.h>

#include <qdialog.h>
#include <qstring.h>
#include <qtooltip.h>
#include "OmSourceVersionNo.h"
#include <vector>
#include <map>
#include <iostream>
#include <qspinbox.h>
class   OmSourceParameters;
class OmSourceButton;
class OmSourceLabel;
class QTable;
class OmImageDisplay;
class QTimer;
class OmSourceParameter;
class OmSourceLabel;
class QSpinBox;
class Average;
class QCheckBox;
class OmSpinBox;
class QTime;
class OmSourceBrowser;





/*********************************************************
 *
 *
 ********************************************************/
class AddSourcesDlg : public QDialog
{
    Q_OBJECT
     
 private slots:
      void deleteList();    
    void mousePressEvent( QMouseEvent *e );
    void updateRegions(); 
    void apertureRadiusHasChanged(int radius);
    void accept1();    
    void cancel1();
    void oldRegionColourChanged(int);

    void newRegionColourChanged(int);

    void updateTimeChanged( int no );

    void redrawRegions();

    void showHelpInformation();




public:
    AddSourcesDlg(QWidget *parent,  OmImageDisplay *imageDispaly, float);
    ~AddSourcesDlg();
 
 private:

    void updateTable(float x, float y, float radius, 
           float counts, OmSourceParameter & );
    void update();
    void enableButtons();
    void disableButtons();
    OmSourceBrowser *_browser; 
    OmImageDisplay *_imageDisplay;
    OmSourceParameter* _source;
   
    OmSourceButton* _deleteListBtn;    
    OmSourceButton* _okBtn;    
    OmSourceButton* _cancelBtn;    

    OmSourceLabel* _label;
    QTable *_table;
    OmSpinBox*  _spinBoxColour1;
    OmSpinBox*  _spinBoxColour2;
    QSpinBox*  _spinBoxUpdate;
  
    QTimer *_timer;
    QTimer *_regionTimer;

    float _apertureRadius; 
    


    OmSourceLabel* _apertureTxt;
    QSpinBox* _apertureSpinBox;
    QCheckBox* _centroidButton;  
 
    vector<float>  _radiusList; 
    float _nx, _ny;
    int _time;
    bool _oldSources;       

};

#endif




