// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#ifndef OmSourceDetectDialog_h
#define OmSourceDetectDialog_h
#include <qapplication.h>
#include <qdialog.h>
#include <qstring.h>
#include <qcheckbox.h>
#include "OmSourceBrowser.h"
#include "qdatetime.h"
class QSpinBox;

class OmSourceLabel;;
class OmSourceButton;
class QProcess;
class QTextEdit;
class QComboBox;
class OmSourceGroupBox;
class QTimer;
class QTime;
class DetectionDlg : public QDialog
{
    Q_OBJECT
     
 private slots:
    void setnSigma(int value) {_nSigma = value;  };
    void setminSignificance(int value) {_minSignificance = value;  };

    void runOmdetect();    
    
    void finished();    
    void terminate(); 
    void quit() {done(OmSourceBrowser::FAILED); };
    void slotDataOnStdout();
    void updateCputime();
      public:
    DetectionDlg(QWidget *parent, QString imageFile, QString sourceListFile);
    ~DetectionDlg();
    float getnSigma() { return float(_nSigma);};
    float getminSignificance() { return float(_minSignificance); }; 
    bool  getDetectExtended() { return _detectExtendedCheck->isChecked() ; }; 
 
 private:

    QString _imageFile;
    QString _sourceListFile;
 
    int _nSigma;
    int _minSignificance;
    OmSourceLabel* _label;
   
    OmSourceLabel* _label1;
    OmSourceLabel* _label2;
    OmSourceLabel* _cpuLabel;

    QSpinBox* _spinBox1;
    QSpinBox* _spinBox2;
    QCheckBox* _detectExtendedCheck;
    OmSourceButton* _terminateBtn;
    OmSourceButton* _quitBtn;
    OmSourceButton* _computeBtn;

    OmSourceGroupBox* _group;
    QProcess* _process;
    QTextEdit* _edit;
    QComboBox* _omdetectComboBox;
    bool _interupted;
    QTime _time;
    QTimer* _timer;
 
};
#endif

