// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include <qtooltip.h>
#include <qstring.h>
#include <qlineedit.h>
#include <qwidget.h>
#include <qlabel.h>
#include "OmSourceEdit.h"
#include <qfont.h>
#include <qfontinfo.h>
#include <qfontmetrics.h>

OmSourceEdit::OmSourceEdit(QWidget *parent, QString title, 
       int x, int y, int height, QString help) :
       QLineEdit(parent, title)
{
    
      
    QFontMetrics fm = this->fontMetrics();
    
 
    int pixelWidth = fm.width(title ) + 5;

       
    setGeometry(x, y, pixelWidth, height);


   
    setAlignment( Qt::AlignHCenter | Qt::AlignVCenter );
   
    setReadOnly(true);


    if (help)   
        QToolTip::add(this, help);

};
OmSourceEdit::OmSourceEdit(QWidget *parent, QString title, 
       int x, int y, int width, int height, QString help) :
       QLineEdit(title, parent)
{
    
   
   
    setGeometry(x, y, width, height);
    setAlignment( Qt::AlignHCenter | Qt::AlignVCenter );
    setReadOnly(true);
         

    if (help)   
        QToolTip::add(this, help);

};
void OmSourceEdit::setText(const QString &text)
{
   
    QFontMetrics fm = this->fontMetrics();
 
    int pixelWidth = fm.width(text ) + 5;

       
    setGeometry(x(), y(), pixelWidth, height());

    QLineEdit::setText(text);
}
 








