// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#ifndef OmSourceGraphDlg_h
#define OmSourceGraphDlg_h
#include <qapplication.h>

#include <qdialog.h>
#include <qstring.h>
#include <qcheckbox.h>
#include "OmSourcePrint.h"
class QPainter;
class QString;
class Graph;
class QTimer;
/****************************************************
*
***************************************************/
class GraphDlg : public QDialog, OmSourcePrint
{
    Q_OBJECT
       signals:


     
 private slots:
      void quit() {reject(); };     
      void printDiagram();
      void loadData();       
      public:
   
    GraphDlg(QWidget *parent, Graph *graph); 
    
    ~GraphDlg(); 
 public:
   void Print(QPrinter* , QPainter* p,  
               QFontMetrics* fm,  QPaintDeviceMetrics* metrics);


 private:
    void paintEvent(QPaintEvent*);  
   
    void drawGraph(QPainter *painter);
 
    Graph *_graph;
   
    QTimer *_timer;;



  
};

#endif



