// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// -*-C++-*-
//
// File:      OmSource.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Sep 13 17:00:17 CEST 2002
// Usage:     -
// Info:      -

#ifndef OmSourceLabelEdit_h
#define OmSourceLabelEdit_h
#include <qwidget.h>
#include <qlineedit.h>
#include <qstring.h>
class OmSourceLabel;
class OmSourceEdit;
class QWidget;
class OmSourceLabelEdit : public QWidget
{
  //     Q_OBJECT  
public:
   OmSourceLabelEdit(QWidget *parent,
		   QString labelString,	     
		   QString editString, 
		   int xPos, int yPos, int height,  
                   QString help = QString::null); 
        
         

   virtual ~OmSourceLabelEdit() {};
   virtual void setText(const QString &);
private:
  
  OmSourceLabel * _label;   // The label will lie to the left of the edit box
  OmSourceEdit * _edit;     // To dispaly a number to the right of the label
  QString _labelName;    
  

};
#endif





