// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#ifndef AVERAGE_h
#define AVERAGE_h

class Average
{

 public:

  Average() : sum1(0.0), sum2(0.0), sum3(0.0), sum4(0.0) {};
  ~Average() {}; 
  float ComputeAverage(const int size, const float* x, const float* dx, float &std);
  float UpdateAverage(const float x, const float dx, float&);
  float UpdateAverage(const int size, const float *x, const float *dx, float&);

  void reset() { sum1 = sum2 = sum3 = sum4 = 0.0;}; 
 private:
  
    double sum1;
    double sum2;
    double sum3;
    double sum4; 
      


};


#endif

